# distutils: language = c++
# cython: language_level = 3
from libc.stdio cimport printf
from cython.parallel import prange

ctypedef int I_t
ctypedef double D_t

cdef void prange_workaround(Clazz instance) nogil:
    cdef:
        I_t i
    printf("prange_workaround: start\n")
    for i in prange(10, schedule='static', num_threads=10):
        printf("Inner method: %d\n", i)
        instance.inner_method()
    printf("prange_workaround: end\n")


cdef cypclass Clazz:

    void outer_method(Clazz self):
        printf("Outer method: start\n")
        prange_workaround(self)
        printf("Outer method: finish\n")

    # Exception handling with prange makes the
    # execution block for some reasons.
    double inner_method(Clazz self) except -1:
        return 0.0
